program OpenProgmanGroup;
{	Installed in a Progman group, this program will open the
	progman-group thats name has been stated as commandline parameter
	So you can have in your Main group a "Stuff" Icon which opens the "Stuff" group
	that contains Icons which represent the groups Rubbish_1 to
	Rubbish_xx... My ProgMan has shrunk to a quarter of the screen!

	If you want more: Neil J. Rubenking, 72241,50 knows how, he wrote:
	"	You can query ProgMan via DDE to get the list of groups, and you can
		query it on each group name to get the items within that group.
		It's POSSIBLE that the list you receive is in order, that the first item
		is the one that has the focus.

		If you want to nab some Pascal code related to this topic, drop by
		ZiffNet's TIPS forum and download the code related to a Lab Notes article
		I wrote a couple years ago on GRP files, and also get the code for the
		WINTIDY utility. The latter relies on the former. You need BOTH.
		WINTIDY uses both DDE query *and* GRP file manipulation.
	"
	Neil's code is ok, great for inspiration.

	I decided (after several heavy bombs) not to add menus to "my" group Icons,
	presenting the option to start a program in the underlying group.
	One quite often goes one step too far...

	Rudolf Regez, 100014,2516
	Oct. 19, 1994, 8952 Schlieren, Switzerland
}
uses 	WinTypes, WinProcs,Strings;
{$R ALIAS} {just a few Icons}
var c255,LookFor:array[0..255] of char;
		i,j:Integer;
(********************************)
function	 OpenGroup(LookFor:PChar):Boolean;
var	TheMainHwnd,TheMDIClientHwnd,TheChildHwnd,Last:Hwnd;
		found:Boolean;
begin
	found:=false;
	TheMainHwnd:=FindWindow('Progman',nil);
	if TheMainHwnd<>0 then begin
		TheMDIClientHwnd:=GetWindow(TheMainHwnd, GW_Child);
		TheChildHwnd:=GetWindow(TheMDIClientHwnd, GW_Child);
		i:=GetWindowText(TheChildHwnd,c255,255);
		if i>0 then
			if StrIComp(LookFor,c255)=0 then found:=true;
		if (TheChildHwnd<>0)  and (not found)  then begin
			Last:=GetWindow(TheChildHwnd, GW_HWNDLast);
			j:=0;
			Repeat
				inc(j);
				if not found then
					TheChildHwnd:=GetWindow(TheChildHwnd, GW_HWNDNext);
				i:=GetWindowText(TheChildHwnd,c255,255);
				if i>0 then
					if StrIComp(LookFor,c255)=0 then found:=true;
			until found or (TheChildHwnd=0) or (TheChildHwnd=Last) or (j>=100)
			{no never ending stories here...The hammer solution}
		end;
	end;
	if found then begin
		BringWindowToTop(TheMainHwnd);
		ShowWindow(TheMainHwnd,SW_SHOWNORMAL);
		BringWindowToTop(TheChildHwnd);
		ShowWindow(TheChildHwnd,SW_SHOWNORMAL);
		OpenGroup:=true;
	end
	else OpenGroup:=false;
end;
(********************************)
begin
	if ParamCount<1 then begin
		messageBox(GetFocus,'Can open ProgMan groups if you give me the title of one in my commandline!','Got no parameters!',mb_ok);
	end
	else begin
		StrPCopy(LookFor,ParamStr(1));
		for i:=2 to ParamCount do begin
			StrPCopy(c255,ParamStr(i));
			StrCat(LookFor,' ');       	{ParamStr takes spaces (#32) as delimiters}
			StrCat(LookFor,c255);       {some people love them in titles..}
		end;
		if not OpenGroup(LookFor) then begin
			messageBox(GetFocus,'Can open ProgMan groups if you give me the title of one in my commandline!'
					,StrCat('Wrong commandline parameter: ',StrUpper(lookFor)),mb_ok);
		end;
	end;
end.
